﻿// XML ticker - Actionscript 3 Version - 2008
//
// based on "effects_ticker" (but with XML support)
//
// Jim Bumgardner
//
package {
	
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.ui.Keyboard;

	public class XML_Ticker
	{
		var parMC;
		// These arrays are loaded from the XML array
		var myLoader:URLLoader;
		
		public function XML_Ticker(parMC, xmlToLoad)
		{
			this.parMC = parMC;

			myLoader = new URLLoader();
			myLoader.addEventListener(Event.COMPLETE, xmlLoadHandler);
			myLoader.load(new URLRequest(xmlToLoad));
		}
	
		function xmlLoadHandler(evt)
		{
			loadXML(myLoader);
			
			TickerSprite.startTicker(parMC);
		}

		loadXML = function(myLoader:URLLoader)
		{
			var myXML = XML(myLoader.data);
			var defColor = undefined;
			var defURL = undefined;

			if (myXML.hasOwnProperty('ticker')) {
				if (myXML.ticker.@color != undefined)
					defColor = new String(myXML.ticker.@color);
				if (myXML.ticker.@url != undefined)
					defURL = new String(myXML.ticker.@url);
			}
			for each (var tickeritem:XML in myXML..tickeritem)
			{
				txt = new String(tickeritem);
				txt = txt.split('[').join('<'); // replace '[' with '<'
				txt = txt.split(']').join('>'); // replace ']' with '>'
				var clr = defColor;
				if (tickeritem.@color != undefined)
					clr = new String(tickeritem.@color);
				var url = defURL;
				if (tickeritem.@url != undefined)
					url = new String(tickeritem.@url);
				if (clr != undefined)
					txt = '<font color="' + clr + '">' + txt + '</font>';
				if (url != undefined)
					txt = '<a href="' + url + '">' + txt + '</a>';
				TickerSprite.addTickerItem( { 'debut': new String(tickeritem.@debut), 
												 'exit': new String(tickeritem.@exit),
									'txt': txt } );
			}
		}
	} // end class
} // end package


